# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/filters/network/generic_proxy/action/v3/action.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass
from datetime import timedelta
from typing import Dict

import betterproto
import betterproto.lib.google.protobuf as betterproto_lib_google_protobuf

from .......config.core import v3 as ______config_core_v3__
from .......config.route import v3 as ______config_route_v3__


@dataclass(eq=False, repr=False)
class RouteAction(betterproto.Message):
    """Configuration for the route match action. [#next-free-field: 8]"""

    name: str = betterproto.string_field(5)
    """
    The name of the route action. This should be unique across all route
    actions.
    """

    cluster: str = betterproto.string_field(1, group="cluster_specifier")
    """
    Indicates the upstream cluster to which the request should be routed.
    """

    weighted_clusters: "______config_route_v3__.WeightedCluster" = (
        betterproto.message_field(2, group="cluster_specifier")
    )
    """
    [#not-implemented-hide:] Multiple upstream clusters can be specified for a
    given route. The request is routed to one of the upstream clusters based on
    weights assigned to each cluster. Currently ClusterWeight only supports the
    name and weight fields.
    """

    metadata: "______config_core_v3__.Metadata" = betterproto.message_field(3)
    """Route metadata."""

    per_filter_config: Dict[str, "betterproto_lib_google_protobuf.Any"] = (
        betterproto.map_field(4, betterproto.TYPE_STRING, betterproto.TYPE_MESSAGE)
    )
    """
    Route level config for L7 generic filters. The key should be the related
    :ref:`extension name
    <envoy_v3_api_field_config.core.v3.TypedExtensionConfig.name>` in the
    :ref:`generic filters <envoy_v3_api_field_extensions.filters.network.generi
    c_proxy.v3.GenericProxy.filters>`.
    """

    timeout: timedelta = betterproto.message_field(6)
    """
    Specifies the upstream timeout for the route. If not specified, the default
    is 15s. This spans between the point at which the entire downstream request
    (i.e. end-of-stream) has been processed and when the upstream response has
    been completely processed. A value of 0 will disable the route's timeout.
    """

    retry_policy: "______config_core_v3__.RetryPolicy" = betterproto.message_field(7)
    """
    Specifies the retry policy for the route. If not specified, then no retries
    will be performed. .. note::   Only simplest retry policy is supported and
    only ``num_retries`` field is used for generic   proxy. The default value
    for ``num_retries`` is 1 means that the request will be tried once   and no
    additional retries will be performed.
    """
