# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: envoy/extensions/quic/server_preferred_address/v3/datasource.proto, envoy/extensions/quic/server_preferred_address/v3/fixed_server_preferred_address_config.proto
# plugin: python-betterproto
# This file has been @generated

from dataclasses import dataclass

import betterproto

from .....config.core import v3 as ____config_core_v3__


@dataclass(eq=False, repr=False)
class DataSourceServerPreferredAddressConfig(betterproto.Message):
    """Configuration for DataSourceServerPreferredAddressConfig."""

    ipv4_config: "DataSourceServerPreferredAddressConfigAddressFamilyConfig" = (
        betterproto.message_field(1)
    )
    """
    The IPv4 address to advertise to clients for Server Preferred Address.
    """

    ipv6_config: "DataSourceServerPreferredAddressConfigAddressFamilyConfig" = (
        betterproto.message_field(2)
    )
    """
    The IPv6 address to advertise to clients for Server Preferred Address.
    """


@dataclass(eq=False, repr=False)
class DataSourceServerPreferredAddressConfigAddressFamilyConfig(betterproto.Message):
    """
    Addresses for server preferred address for a single address family (IPv4 or
    IPv6).
    """

    address: "____config_core_v3__.DataSource" = betterproto.message_field(1)
    """
    The server preferred address sent to clients. The data must contain an IP
    address string.
    """

    port: "____config_core_v3__.DataSource" = betterproto.message_field(2)
    """
    The server preferred address port sent to clients. The data must contain a
    integer port value. If this is not specified, the listener's port is used.
    Note: Envoy currently must receive all packets for a QUIC connection on the
    same port, so unless :ref:`dnat_address <envoy_v3_api_field_extensions.quic
    .server_preferred_address.v3.DataSourceServerPreferredAddressConfig.Address
    FamilyConfig.dnat_address>` is configured, this must be left unset.
    """

    dnat_address: "____config_core_v3__.DataSource" = betterproto.message_field(3)
    """
    If there is a DNAT between the client and Envoy, the address that Envoy
    will observe server preferred address packets being sent to. If this is not
    specified, it is assumed there is no DNAT and the server preferred address
    packets will be sent to the address advertised to clients for server
    preferred address.
    """


@dataclass(eq=False, repr=False)
class FixedServerPreferredAddressConfig(betterproto.Message):
    """Configuration for FixedServerPreferredAddressConfig."""

    ipv4_address: str = betterproto.string_field(1)
    """
    String representation of IPv4 address, i.e. "127.0.0.2". If not specified,
    none will be configured.
    """

    ipv4_config: "FixedServerPreferredAddressConfigAddressFamilyConfig" = (
        betterproto.message_field(3)
    )
    """
    The IPv4 address to advertise to clients for Server Preferred Address. This
    field takes precedence over :ref:`ipv4_address <envoy_v3_api_field_extensio
    ns.quic.server_preferred_address.v3.FixedServerPreferredAddressConfig.ipv4_
    address>`.
    """

    ipv6_address: str = betterproto.string_field(2)
    """
    String representation of IPv6 address, i.e. "::1". If not specified, none
    will be configured.
    """

    ipv6_config: "FixedServerPreferredAddressConfigAddressFamilyConfig" = (
        betterproto.message_field(4)
    )
    """
    The IPv6 address to advertise to clients for Server Preferred Address. This
    field takes precedence over :ref:`ipv6_address <envoy_v3_api_field_extensio
    ns.quic.server_preferred_address.v3.FixedServerPreferredAddressConfig.ipv6_
    address>`.
    """


@dataclass(eq=False, repr=False)
class FixedServerPreferredAddressConfigAddressFamilyConfig(betterproto.Message):
    """
    Addresses for server preferred address for a single address family (IPv4 or
    IPv6).
    """

    address: "____config_core_v3__.SocketAddress" = betterproto.message_field(1)
    """
    The server preferred address sent to clients. Note: Envoy currently must
    receive all packets for a QUIC connection on the same port, so unless
    :ref:`dnat_address <envoy_v3_api_field_extensions.quic.server_preferred_add
    ress.v3.FixedServerPreferredAddressConfig.AddressFamilyConfig.dnat_address>
    ` is configured, the port for this address must be zero, and the listener's
    port will be used instead.
    """

    dnat_address: "____config_core_v3__.SocketAddress" = betterproto.message_field(2)
    """
    If there is a DNAT between the client and Envoy, the address that Envoy
    will observe server preferred address packets being sent to. If this is not
    specified, it is assumed there is no DNAT and the server preferred address
    packets will be sent to the address advertised to clients for server
    preferred address. Note: Envoy currently must receive all packets for a
    QUIC connection on the same port, so the port for this address must be
    zero, and the listener's port will be used instead.
    """
